package com.eactive.eai.batch.job.jobItem.cms25;

import java.io.ByteArrayOutputStream;
import java.util.HashMap;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobHandle.JobProcessData;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.common.exception.ExceptionUtil;

public class RECV_CMS25_0310 extends DefaultTelegram implements TelegramService
{

    private int INFORMALFIELD_INDEX = 12;
    private ByteArrayOutputStream bout;

    /**
     * 생성자
     */
    public RECV_CMS25_0310() {
        //결번 DATA 송신
        bout = new ByteArrayOutputStream();
    }

    /**
     * 전문 해체하기
     */
    public boolean doExecute() {
        if (!super.doExecute()) return false;
        try {
            String _block_no     = new String ((byte[]) al_Field.get(9));
            String _seq_no       = new String ((byte[]) al_Field.get(10));
            int recv_block_no    = Integer.parseInt(_block_no);
            int recv_seq_no      = Integer.parseInt(_seq_no);
            int block_no         = batchDoc.getBatchMsg().getBody().getBlockNum();
            String missing_field = batchDoc.getBatchMsg().getBody().getMissingNmField();
//            int missingCount     = batchDoc.getBatchMsg().getBody().getMissingNmCount();

//            //중간 블럭 데이터 손실되었거나, 지금까지 수신한 블럭의 크기가 현재 받은 블럭의 크기보다 크면 Error
//            if ((recv_block_no - block_no) > 1 || (recv_block_no - block_no) < 0 ){
//                this.setConditionTxt(TelegramKeys.ERROR);
//                String[] msgArgs = new String[3];
//                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
//                msgArgs[1] = _block_no;
//                msgArgs[2] = ""+block_no;
//                String errCode = "BECEAIFJI024";
//                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
//                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
//                return false;
//            }

            if ( recv_block_no == block_no ){
                byte[] _missing_field = missing_field.getBytes();
                if (_missing_field[recv_seq_no-1] == '0') {
                    _missing_field[recv_seq_no-1] = '1';
//                    missingCount -= 1;
                    batchDoc.getBatchMsg().getBody().setMissingNmField(new String(_missing_field));
                    logger.info("{} doExecute> RECV missing telegram [" + recv_seq_no + "] missing field" + new String(_missing_field), logHeader);
                } else {
                	logger.info("{} doExecute> recived recv_seq_no is not missing field", logHeader);
                }
            }
            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }

    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;
        try {
            JobProcessData job = JobProcessData.getInstance();
            String uuid = this.batchDoc.getBatchMsg().getHeader().getUUID();
            HashMap<String, Object> hm = job.getBatchStageData(uuid);

            @SuppressWarnings("unchecked")
            HashMap<Integer, byte[]> block_data = (HashMap<Integer, byte[]>)hm.get(JobProcessData.PROCDATA_BLOCKDATA);
            if (block_data == null ){
                block_data = new HashMap<Integer, byte[]>();
            }

            String _block_no     = new String ((byte[]) al_Field.get(9));
            String _seq_no       = new String ((byte[]) al_Field.get(10));
            int recv_block_no    = Integer.parseInt(_block_no);
            int recv_seq_no      = Integer.parseInt(_seq_no);
            int block_no         = batchDoc.getBatchMsg().getBody().getBlockNum();

            logger.info("{} doInformalField >> missing telegram receive : [" + (recv_seq_no-1) + "]", logHeader);
            if ( recv_block_no == block_no ){
                if (block_data.get(new Integer(recv_seq_no-1)) == null) {
                    block_data.put(new Integer(recv_seq_no-1), bout.toByteArray());
                    hm.put(JobProcessData.PROCDATA_BLOCKDATA, block_data);
                }
            }

            

            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<9; i++) { //CMS전문의 헤더는 응답코드까지 임.
                byte[] barr = (byte[])this.al_Field.get(i);
                if ( barr[0] != '\0') {
                    baout.write((byte[])this.al_Field.get(i));
                }
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=9; i< al_Field.size()-1; i++) {  //결번확인 필드는 비정형 필드로 바디 로그에서 제외
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            return true;

        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    /**
     * 전문 Validation
     */
    public boolean doValidation()
    {
        if (!super.doValidation()) return false;
        return true;
    }

    /**
     * int getCalculatedLength(int idx)
     * --------------------------------------------------------------------------------------
     * 전달된 인덱스 idx는 비정형 필드여야 한다. 즉 필드의 길이값이 FILE_NO_LENGTH("XX") 이어야 한다.
     * 해당 비정형 필드에 대해 실질적인 전문길이를 동적으로 계산해 낸다.
     * SEND : 송신 길이 계산
     * RECV : 수신 길이 계산
     */
    public int getCalculatedLength(int idx) {
        if (idx >= this.getFieldCount()) {
        	 logger.debug("{} getCalculatedLength> parameter is bigger than field count", logHeader);
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI011";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
        if (this.getFieldLength(idx).equalsIgnoreCase(TelegramService.FIELD_NO_LENGTH)) {
            try {
                String byte_size = new String ((byte[]) al_Field.get(0));
                int tot_byte_size = Integer.parseInt(byte_size);
                int read_byte_size = 0;
                for (int i=1; i < idx; i++){
                    read_byte_size += al_Field.get(i).length;
                }
                try {
                    if ( Integer.parseInt( getTelegramInfo().getProperty(TelegramKeys.TRCD_LEN) ) == 0 )
                        read_byte_size -= 1;
                }catch(Exception e1) {}
                return tot_byte_size - read_byte_size;
            } catch(Exception e) {
                String[] msgArgs = new String[1];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                String errCode = "BECEAIFJI005";
                String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                logger.error( e.getMessage(), e);
                return -1;
            }
        } else {
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI012";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
    }

    public boolean doInformalField(int idx, byte[] data, int length)
    {
        try {
            if (idx == INFORMALFIELD_INDEX) {
                bout.write(data, 0, length);
            } else {
            	logger.debug("{} doInformalField >> index of informal action error : " + idx, logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI012";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return false;
            }
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI004";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
        return true;
    }

    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        return super.getFieldValueString(4);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
        return super.getFieldValueString(5);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
        return super.getFieldValueString(8);
    }
    //업무관리코드 필드값 리턴
    public String getOpCode()
    {
        return super.getOpCode();
    }
}